using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using Oqtane.Services;
using Oqtane.Shared;

namespace AdamGais.Module.AnmeldeTool.Services
{
    public class AnmeldeToolService : ServiceBase, IAnmeldeToolService
    {
        public AnmeldeToolService(HttpClient http, SiteState siteState) : base(http, siteState) { }

        private string Apiurl => CreateApiUrl("AnmeldeTool");

        public async Task<List<Models.AnmeldeTool>> GetAnmeldeToolsAsync(int ModuleId)
        {
            List<Models.AnmeldeTool> AnmeldeTools = await GetJsonAsync<List<Models.AnmeldeTool>>(CreateAuthorizationPolicyUrl($"{Apiurl}?moduleid={ModuleId}", EntityNames.Module, ModuleId), Enumerable.Empty<Models.AnmeldeTool>().ToList());
            return AnmeldeTools.OrderBy(item => item.Name).ToList();
        }

        public async Task<Models.AnmeldeTool> GetAnmeldeToolAsync(int AnmeldeToolId, int ModuleId)
        {
            return await GetJsonAsync<Models.AnmeldeTool>(CreateAuthorizationPolicyUrl($"{Apiurl}/{AnmeldeToolId}/{ModuleId}", EntityNames.Module, ModuleId));
        }

        public async Task<Models.AnmeldeTool> AddAnmeldeToolAsync(Models.AnmeldeTool AnmeldeTool)
        {
            return await PostJsonAsync<Models.AnmeldeTool>(CreateAuthorizationPolicyUrl($"{Apiurl}", EntityNames.Module, AnmeldeTool.ModuleId), AnmeldeTool);
        }

        public async Task<Models.AnmeldeTool> UpdateAnmeldeToolAsync(Models.AnmeldeTool AnmeldeTool)
        {
            return await PutJsonAsync<Models.AnmeldeTool>(CreateAuthorizationPolicyUrl($"{Apiurl}/{AnmeldeTool.AnmeldeToolId}", EntityNames.Module, AnmeldeTool.ModuleId), AnmeldeTool);
        }

        public async Task DeleteAnmeldeToolAsync(int AnmeldeToolId, int ModuleId)
        {
            await DeleteAsync(CreateAuthorizationPolicyUrl($"{Apiurl}/{AnmeldeToolId}/{ModuleId}", EntityNames.Module, ModuleId));
        }
    }
}
