using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Migrations.Operations;
using Microsoft.EntityFrameworkCore.Migrations.Operations.Builders;
using Oqtane.Databases.Interfaces;
using Oqtane.Migrations;
using Oqtane.Migrations.EntityBuilders;

namespace AdamGais.Module.AnmeldeTool.Migrations.EntityBuilders
{
    public class AnmeldeToolEntityBuilder : AuditableBaseEntityBuilder<AnmeldeToolEntityBuilder>
    {
        private const string _entityTableName = "AdamGaisAnmeldeTool";
        private readonly PrimaryKey<AnmeldeToolEntityBuilder> _primaryKey = new("PK_AdamGaisAnmeldeTool", x => x.AnmeldeToolId);
        private readonly ForeignKey<AnmeldeToolEntityBuilder> _moduleForeignKey = new("FK_AdamGaisAnmeldeTool_Module", x => x.ModuleId, "Module", "ModuleId", ReferentialAction.Cascade);

        public AnmeldeToolEntityBuilder(MigrationBuilder migrationBuilder, IDatabase database) : base(migrationBuilder, database)
        {
            EntityTableName = _entityTableName;
            PrimaryKey = _primaryKey;
            ForeignKeys.Add(_moduleForeignKey);
        }

        protected override AnmeldeToolEntityBuilder BuildTable(ColumnsBuilder table)
        {
            AnmeldeToolId = AddAutoIncrementColumn(table,"AnmeldeToolId");
            ModuleId = AddIntegerColumn(table,"ModuleId");
            Name = AddMaxStringColumn(table,"Name");
            AddAuditableColumns(table);
            return this;
        }

        public OperationBuilder<AddColumnOperation> AnmeldeToolId { get; set; }
        public OperationBuilder<AddColumnOperation> ModuleId { get; set; }
        public OperationBuilder<AddColumnOperation> Name { get; set; }
    }
}
