using Microsoft.EntityFrameworkCore;
using Microsoft.AspNetCore.Http;
using Oqtane.Modules;
using Oqtane.Repository;
using Oqtane.Infrastructure;
using Oqtane.Repository.Databases.Interfaces;

namespace AdamGais.Module.AnmeldeTool.Repository
{
    public class AnmeldeToolContext : DBContextBase, ITransientService, IMultiDatabase
    {
        public virtual DbSet<Models.AnmeldeTool> AnmeldeTool { get; set; }

        public AnmeldeToolContext(IDBContextDependencies DBContextDependencies) : base(DBContextDependencies)
        {
            // ContextBase handles multi-tenant database connections
        }

        protected override void OnModelCreating(ModelBuilder builder)
        {
            base.OnModelCreating(builder);

            builder.Entity<Models.AnmeldeTool>().ToTable(ActiveDatabase.RewriteName("AdamGaisAnmeldeTool"));
        }
    }
}
